Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkLinkEdgels Class Reference

`#include <vtkLinkEdgels.h>`

Inheritance diagram for vtkLinkEdgels:

[legend]
Collaboration diagram for vtkLinkEdgels:

[legend]
List of all members.

## Detailed Description

links edgels together to form digital curves.

Date:
  2002/09/03 12:52:23

Revision:
  1.28

vtkLinkEdgels links edgels into digital curves which are then stored as polylines. The algorithm works one pixel at a time only looking at its immediate neighbors. There is a GradientThreshold that can be set that eliminates any pixels with a smaller gradient value. This can be used as the lower threshold of a two value edgel thresholding.

For the remaining edgels, links are first tried for the four connected neighbors. A successful neighbor will satisfy three tests. First both edgels must be above the gradient threshold. Second, the difference between the orientation between the two edgels (Alpha) and each edgels orientation (Phi) must be less than LinkThreshold. Third, the difference between the two edgels Phi values must be less than PhiThreshold. The most successful link is selected. The measure is simply the sum of the three angle differences (actually stored as the sum of the cosines). If none of the four connect neighbors succeeds, then the eight connect neighbors are examined using the same method.

This filter requires gradient information so you will need to use a vtkImageGradient at some point prior to this filter. Typically a vtkNonMaximumSuppression filter is also used. vtkThresholdEdgels can be used to complete the two value edgel thresholding as used in a Canny edge detector. The vtkSubpixelPositionEdgels filter can also be used after this filter to adjust the edgel locations.

See also:
  vtkImage vtkImageGradient vtkNonMaximumSuppression

Created by:
  - Martin, Ken

CVS contributions (if > 5%):
  - Martin, Ken (79%)
  - Law, Charles (8%)
  - Geveci, Berk (5%)

CVS logs (CVSweb):
  - .`h` (`/Graphics/vtkLinkEdgels.h)`
  - .`cxx` (`/Graphics/vtkLinkEdgels.cxx)`

Tests:
  vtkLinkEdgels (Tests)

Definition at line 76 of file vtkLinkEdgels.h.

## Public Types
typedef vtkStructuredPointsToPolyDataFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual void | SetLinkThreshold (float)
virtual float | GetLinkThreshold ()
virtual void | SetPhiThreshold (float)
virtual float | GetPhiThreshold ()
virtual void | SetGradientThreshold (float)
virtual float | GetGradientThreshold ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkLinkEdgels * | SafeDownCast (vtkObject *o)
vtkLinkEdgels * | New ()
## Protected Methods
| vtkLinkEdgels ()
| ~vtkLinkEdgels ()
void | Execute ()
void | LinkEdgels (int xdim, int ydim, float *image, vtkDataArray *inVectors, vtkCellArray *newLines, vtkPoints *newPts, vtkFloatArray *outScalars, vtkFloatArray *outVectors, int z)
## Protected Attributes
float | GradientThreshold
float | PhiThreshold
float | LinkThreshold

## Member Typedef Documentation

typedef vtkStructuredPointsToPolyDataFilter vtkLinkEdgels::Superclass

| Reimplemented from vtkStructuredPointsToPolyDataFilter. Definition at line 79 of file vtkLinkEdgels.h.

## Constructor & Destructor Documentation

vtkLinkEdgels::vtkLinkEdgels | ( |  | ) | `[protected]`

vtkLinkEdgels::~vtkLinkEdgels | ( |  | ) | `[inline, protected]`

| Definition at line 107 of file vtkLinkEdgels.h.

## Member Function Documentation

virtual const char* vtkLinkEdgels::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkStructuredPointsToPolyDataFilter.

int vtkLinkEdgels::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkStructuredPointsToPolyDataFilter.

virtual int vtkLinkEdgels::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkStructuredPointsToPolyDataFilter.

vtkLinkEdgels* vtkLinkEdgels::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkStructuredPointsToPolyDataFilter.

void vtkLinkEdgels::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkStructuredPointsToPolyDataFilter.

vtkLinkEdgels* vtkLinkEdgels::New | ( |  | ) | `[static]`

| Construct instance of vtkLinkEdgels with GradientThreshold set to 0.1, PhiThreshold set to 90 degrees and LinkThreshold set to 90 degrees. Reimplemented from vtkObject.

virtual void vtkLinkEdgels::SetLinkThreshold | ( | float |  | ) | `[virtual]`

| Set/Get the threshold for Phi vs. Alpha link thresholding.

virtual float vtkLinkEdgels::GetLinkThreshold | ( |  | ) | `[virtual]`

| Set/Get the threshold for Phi vs. Alpha link thresholding.

virtual void vtkLinkEdgels::SetPhiThreshold | ( | float |  | ) | `[virtual]`

| Set/get the threshold for Phi vs. Phi link thresholding.

virtual float vtkLinkEdgels::GetPhiThreshold | ( |  | ) | `[virtual]`

| Set/get the threshold for Phi vs. Phi link thresholding.

virtual void vtkLinkEdgels::SetGradientThreshold | ( | float |  | ) | `[virtual]`

| Set/Get the threshold for image gradient thresholding.

virtual float vtkLinkEdgels::GetGradientThreshold | ( |  | ) | `[virtual]`

| Set/Get the threshold for image gradient thresholding.

void vtkLinkEdgels::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

void vtkLinkEdgels::LinkEdgels | ( | int | xdim,
|  | int | ydim,
|  | float * | image,
|  | vtkDataArray * | inVectors,
|  | vtkCellArray * | newLines,
|  | vtkPoints * | newPts,
|  | vtkFloatArray * | outScalars,
|  | vtkFloatArray * | outVectors,
|  | int | z
| ) | `[protected]`

## Member Data Documentation

float vtkLinkEdgels::GradientThreshold`[protected]`

| Definition at line 114 of file vtkLinkEdgels.h.

float vtkLinkEdgels::PhiThreshold`[protected]`

| Definition at line 115 of file vtkLinkEdgels.h.

float vtkLinkEdgels::LinkThreshold`[protected]`

| Definition at line 116 of file vtkLinkEdgels.h.

The documentation for this class was generated from the following file:

- Graphics/vtkLinkEdgels.h